﻿Imports System.Configuration
Imports System.Collections
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls
Imports Telerik.Web.UI
Imports System.Collections.Generic
Imports System.Xml.Serialization
Imports System.IO
Imports System.Xml
Imports System.Web.Script.Serialization
Imports System


Partial Class DefaultVB
    Inherits System.Web.UI.Page

    Private Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim source As New ArrayList()
        source.Add("one")
        source.Add("two")
        source.Add("three")

        GridView1.DataSource = source
        GridView1.DataBind()
    End Sub

    Property MyDockStates() As String
        Get
            Dim _dockStates As String
            Dim positionsCookie As HttpCookie = Request.Cookies("Cookie_Default")
            If positionsCookie Is Nothing Then
                _dockStates = [String].Empty
            Else
                _dockStates = positionsCookie.Value
            End If
            Return _dockStates
        End Get
        Set(ByVal value As String)
            Dim positionsCookie As New HttpCookie("Cookie_Default", value)
            positionsCookie.Expires = DateTime.Now.AddYears(1)
            Response.Cookies.Add(positionsCookie)
        End Set
    End Property

    Protected Sub RadDockLayout1_LoadDockLayout(ByVal sender As Object, ByVal e As Telerik.Web.UI.DockLayoutEventArgs)
        Dim dock As RadDock = Nothing
        Dim serializer As New JavaScriptSerializer()
        Dim converters As New List(Of JavaScriptConverter)()
        converters.Add(New UnitConverter())
        serializer.RegisterConverters(converters)
        For Each str As String In MyDockStates.Split("|"c)
            If str <> [String].Empty Then
                Dim state As DockState = serializer.Deserialize(Of DockState)(str)
                dock = DirectCast(RadDockLayout1.FindControl(state.UniqueName), RadDock)
                dock.ApplyState(state)
            End If
        Next
    End Sub

    Protected Sub RadDockLayout1_SaveDockLayout(ByVal sender As Object, ByVal e As Telerik.Web.UI.DockLayoutEventArgs)
        Dim dockStates As List(Of DockState) = RadDockLayout1.GetRegisteredDocksState()
        Dim serializer As New JavaScriptSerializer()
        Dim converters As New List(Of JavaScriptConverter)()
        converters.Add(New UnitConverter())
        serializer.RegisterConverters(converters)

        Dim stateString As String = [String].Empty
        For Each state As DockState In dockStates
            Dim ser As String = serializer.Serialize(state)
            stateString = stateString + "|" + ser
        Next
        MyDockStates = stateString
    End Sub

    

End Class
